routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('backoffice.home');
});

Auth::routes();

Route::get('/home', 'HomeController@index')->name('home');
Route::middleware('auth')->group(function () {
    Route::resource('products','ProductsController')->except([
        "show"
    ]);
    Route::resource('categories','CategoriesController')->except([
        "show"
    ]);
    /*
		Commands Controller
    */
	Route::get('commands','CommandsController@index')->name('commands.list');
	Route::get('commands/{command}','CommandsController@consulte')->name('commands.consulte');
	Route::delete('commands/delete/{command}','CommandsController@remove')->name('commands.remove');
});

app/Product.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\SoftDeletes;

class Product extends Model
{
    use SoftDeletes;

    protected $guarded = [];

    public function category () {
        return $this->belongsTo(Category::class);
    }
}

app/Http/Controllers/API/ProductsController.php
<?php

namespace App\Http\Controllers\API;

use App\Http\Controllers\Controller;
use App\Product;
use Illuminate\Http\Request;

class ProductsController extends Controller
{
    /**
     * Display the specified resource.
     *
     * @param  \App\Product  $product
     * @return \Illuminate\Http\Response
     */
    public function show(Product $product)
    {
        return response()->json([
            "success" => true,
            "product" => $product,
            "category" => $product->category
        ]);
    }
}

app/Http/Controllers/ProductsController.php
<?php

namespace App\Http\Controllers;

use App\{
    Product,
    Category
};
use Illuminate\Http\Request;
use Illuminate\Support\Str;


class ProductsController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        return view('backoffice.products.index',[
            'products' => Product::with('category')->orderBy('id','DESC')->paginate(15)
        ]);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        return view('backoffice.products.form',[
            "product" => new Product,
            "categories" => Category::all()
        ]);
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $this->validate($request,[
            "title" => "required",
            "description" => "required",
            "price" => "required",
            "main_image" => "required|image",
            "category_id" => "required",
            "stock" => "required",
        ]);
        $fill = $request->only('title','description','price','category_id','stock');
        $fill['price'] = (float)$fill['price'];
        $filename = Str::slug($request->title).".".$request->main_image->getClientOriginalExtension();
        $fill['main_image'] = asset('storage/uploads/'.$filename);
        $request->main_image->storeAs('uploads',$filename,'public');
        Product::create($fill);
        return redirect()->route('products.index')->with('alert',[
            "type" => "success",
            "message" => "Product has been added to database"
        ]);
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\Product  $product
     * @return \Illuminate\Http\Response
     */
    public function edit(Product $product)
    {
        return view("backoffice.products.form",[
            "product" => $product,
            "categories" => Category::all()
        ]);
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\Product  $product
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, Product $product)
    {
        $fill = $this->validate($request,[
            "title" => "required",
            "description" => "required",
            "price" => "required",
            "category_id" => "required",
            "stock" => "required",
        ]);
        if ($request->has('main_image')) {
            $old_image = last(explode('/', $product->main_image));
            unlink(storage_path('app/public/uploads/'.$old_image));
            $filename = Str::slug($request->title).".".$request->main_image->getClientOriginalExtension();
            $fill['main_image'] = asset('storage/uploads/'.$filename);
            $request->main_image->storeAs('uploads',$filename,'public');
        }
        $product->update($fill);
        return redirect()->route('products.index')->with('alert',[
            "type" => "success",
            "message" => "Product has been added to database"
        ]);
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Product  $product
     * @return \Illuminate\Http\Response
     */
    public function destroy(Product $product)
    {
        $product->delete();
        return redirect()->route('products.index')->with('alert',[
            "type" => "info",
            "message" => "Product has been deleted"
        ]);
    }
}

resources/views/backoffice/products/form.blade.php
@extends('layouts.backoffice')

@section('content')
  <!-- .row -->
  <div class="row">
      <div class="col-lg-12">
          <div class="card">
            <div class="card-body">
                <h5 class="card-title block">{{ (is_null($product->id)) ? 'Add product' : 'Edit: '.$product->title }} </h5>
                <br>
                @if(session('alert'))
                    <div class="my-4">
                        <div class="alert alert-{{ session('alert')['type'] }}">
                            {{ session('alert')['message'] }}
                        </div>
                    </div>
                @endif
                @if ($errors->any())
                    <div class="alert alert-danger">
                        <ul>
                            @foreach ($errors->all() as $error)
                                <li>{{ $error }}</li>
                            @endforeach
                        </ul>
                    </div>
                @endif
                <div class="my-4">
                    <form method="post" action="{{ (is_null($product->id)) ? route('products.store') : route('products.update',$product->id) }}" enctype="multipart/form-data">
                        @csrf
                        @if(!is_null($product->id))
                            @method('PUT')
                        @endif
                        <div class="form-group">
                            <label for="title">Title</label>
                            <input type="text" class="form-control" name="title" id="title" placeholder="Product title" value="{{ old('title',$product->title) }}">
                        </div>
                        <div class="form-group">
                            <label for="description">Description</label>
                            <textarea class="form-control" name="description" id="description" placeholder="Product description">{{ old('description',$product->description) }}</textarea>
                        </div>
                        <div class="form-group">
                            <label for="price">Price</label>
                            <input type="text" class="form-control" name="price" id="price" placeholder="Product price" value="{{ old('price',$product->price) }}">
                        </div>
                        <div class="form-group">
                            <label for="category">Category</label>
                            <select type="text" class="form-control" name="category_id" id="category">
                                <option value="" {{ (is_null($product->category_id)) ? 'selected' : ''  }}>Select a category</option>
                                @foreach($categories as $category)
                                    <option value="{{ $category->id }}" {{ ($category->id == $product->category_id || $category->id == old('category_id')) ? 'selected' : '' }}>{{ $category->title }}</option>
                                @endforeach
                            </select>
                        </div>
                        <div class="form-group">
                            <label for="stock">Stock</label>
                            <input min="0" type="number" class="form-control" name="stock" id="stock" placeholder="Product stock" value="{{ old('stock',$product->stock) }}">
                        </div>
                        <div class="form-group">
                            <label for="main_image">Main image</label>
                            <input min="0" type="file" class="form-control-file" name="main_image" id="main_image">
                        </div>
                        <button type="submit" class="btn btn-success">{{ (is_null($product->id)) ? 'Save' : 'Update'}}</button>
                    </form>
                </div>
            </div>
          </div>
      </div>
  </div>
  <!-- /.row -->
@endsection

resources/views/backoffice/products/index.blade.php
@extends('layouts.backoffice')

@section('content')
  <!-- .row -->
  <div class="row">
      <div class="col-lg-12">
          <div class="card">
            <div class="card-body">
                <h5 class="card-title">Products</h5>
                @if(session('alert'))
                    <div class="my-4">
                        <div class="alert alert-{{ session('alert')['type'] }}">
                            {{ session('alert')['message'] }}
                        </div>
                    </div>
                @endif
                @if($products->count() > 0)
                <table class="table table-bordered">
                    <thead>
                        <tr>
                            <th>Id</th>
                            <th>Title</th>
                            <th>Category</th>
                            <th>Created at</th>
                            <th>Last update</th>
                            <th width="200px">Action</th>
                        </tr>
                    </thead>
                    <tbody>
                        @foreach($products as $product)
                            <tr>
                                <td>{{ $product->id }}</td>
                                <td>{{ $product->title }}</td>
                                <td>{{ $product->category->title }}</td>
                                <td>{{ $product->created_at->format('d/m/Y H:i:s') }}</td>
                                <td>{{ $product->updated_at->format('d/m/Y H:i:s') }}</td>
                                <td>
                                    <a href="{{ route('products.edit',$product->id)}}" class="btn btn-sm btn-warning">edit</a>
                                    <form method="post" action="{{ route('products.destroy',$product->id) }}">
                                        @method('DELETE')
                                        @csrf
                                        <button class="btn btn-sm btn-danger">delete</button>
                                    </form>
                                </td>
                            </tr>
                        @endforeach
                    </tbody>
                </table>
                <div class="my-4">
                    {{ $products->links() }}
                </div>
                @else
                    <div class="alert alert-info">
                        <h4>You have no products to display please <a href="{{ route('products.create') }}">create one</a> to get started</h4>
                    </div>
                @endif
            </div>
          </div>
      </div>
  </div>
  <!-- /.row -->
@endsection